var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ApolloLink, Observable } from 'apollo-link';
import { graphql } from 'reactive-graphql';
var ReactiveSchemaLink = /** @class */ (function (_super) {
    __extends(ReactiveSchemaLink, _super);
    function ReactiveSchemaLink(_a) {
        var schema = _a.schema, context = _a.context;
        var _this = _super.call(this) || this;
        _this.schema = schema;
        _this.context = context;
        return _this;
    }
    ReactiveSchemaLink.prototype.request = function (operation) {
        var _this = this;
        return new Observable(function (observer) {
            try {
                var context = typeof _this.context === 'function' ? _this.context(operation) : _this.context || {};
                return graphql(_this.schema, operation.query, null, context, operation.variables).subscribe(observer);
            }
            catch (e) {
                observer.error(e);
            }
        });
    };
    return ReactiveSchemaLink;
}(ApolloLink));
export { ReactiveSchemaLink };
export default ReactiveSchemaLink;
//# sourceMappingURL=reactiveSchemaLink.js.map